﻿using Infragistics.Controls.Grids;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            this.DataContext = ChartData.GenerateData(50);
        }

        private void XamGrid_ActiveCellChanging(object sender, Infragistics.Controls.Grids.ActiveCellChangingEventArgs e)
        {
            if ((sender as XamGrid).GroupBySettings.GroupByColumns.Contains((sender as XamGrid).Columns["Date"]))
            {
                if (e.NewActiveCell.Column.Key == "Date")
                {
                    e.NewActiveCell.Control.Opacity = 1;
                }
                else if (e.PreviousActiveCell != null && e.PreviousActiveCell.Row.Cells["Date"].Control != null)
                {
                    e.NewActiveCell.Row.Cells["Date"].Control.Opacity = 0;
                    e.PreviousActiveCell.Row.Cells["Date"].Control.Opacity = 0;
                }
            }
        }

        private void XamGrid_CellControlAttached(object sender, Infragistics.Controls.Grids.CellControlAttachedEventArgs e)
        {
            if (e.Cell.Column.Key == "Date" && (sender as XamGrid).GroupBySettings.GroupByColumns.Contains((sender as XamGrid).Columns["Date"]))
            {
                e.Cell.Control.Opacity = 0;
            }
        }

        private void XamGrid_GroupByCollectionChanged(object sender, GroupByCollectionChangedEventArgs e)
        {
            if (!e.NewGroupedColumns.Contains((sender as XamGrid).Columns["Date"]))
            {
                foreach (var item in (sender as XamGrid).Rows)
                {
                    if (item.Cells["Date"].Control != null)
                    {
                        item.Cells["Date"].Control.Opacity = 1;
                    }                    
                }
            }
        }
    }

    public class ChartData
    {
        public DateTime Date { get; set; }
        public double Value1 { get; set; }
        public double Value2 { get; set; }
        public double Value3 { get; set; }

        public static ObservableCollection<ChartData> GenerateData(int count)
        {
            ObservableCollection<ChartData> data = new ObservableCollection<ChartData>();

            Random r = new Random();

            ChartData data0 = new ChartData
            {
                Date = DateTime.Now,
                Value1 = r.Next(20, 40),
                Value2 = r.Next(20, 40),
                Value3 = r.Next(20, 40),
            };

            data.Add(data0);

            for (int i = 1; i < count; i++)
            {
                ChartData dat = new ChartData
                {
                    Date = DateTime.Now.AddDays(i%2),
                };



                if (r.NextDouble() > .5)
                {
                    dat.Value1 = data[i - 1].Value1 + r.NextDouble();
                    dat.Value2 = data[i - 1].Value2 + r.NextDouble();
                    dat.Value3 = data[i - 1].Value3 + r.NextDouble();
                }
                else
                {
                    dat.Value1 = data[i - 1].Value1 - r.NextDouble();
                    dat.Value2 = data[i - 1].Value2 - r.NextDouble();
                    dat.Value3 = data[i - 1].Value3 - r.NextDouble();
                }

                data.Add(dat);
            }

            return data;
        }
    }
}
